<?php

/*
 * info.php - the script to display a songs info page
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 */

require_once("config.inc");
require_once("utils.inc");
require_once("mp3genres.inc");
require_once("dbutils.inc");

$HTMLPage->set_title("song info");

if($CSS_FILE!=false)
  $HTMLPage->push_css_link($CSS_FILE);

$table1=new TABLEtag(array("CELLSPACING" => "$TABLE_SPACING",
			   "CELLPADDING" => "0",
			   "BORDER" => "$TABLE_BORDER",
			   "WIDTH" => "$MAX_TABLE_WIDTH",
			   "HEIGHT" => "$MAX_TABLE_HEIGHT"));

$table2=new TABLEtag(array("WIDTH" => "100%"));
$table2->push_row(create_TD(array("class" => "Name", "ALIGN" => "MIDDLE"), "song info"));
$table1->push_row(create_TD(array("class" => "Title", "VALIGN"=>"TOP"), $table2));

if(!$conn)
  $conn=pg_pconnect($DBCONNECT);
if(!$conn)
{
  $table1->push_row(create_TD(array("class"=>"Navigation", "WIDTH"=>"100%", "ALIGN"=>"CENTER"), 
			      create_B("Failed to open the database with \"$DBCONNECT\"")));
}
else
{
  $result=pg_exec($conn, createSongQuery("*", "id=$id", ""));

  $entries_found=pg_numrows($result);
  
  if($entries_found > 0)
  {
    // let's create the update form
    $song=pg_fetch_array($result, 0);

    $table2=new TABLEtag(array("CELLSPACING"=>"4", "CELLPADDING"=>"0", "BORDER"=>"$TABLE_BORDER", "WIDTH"=>"100%"));

    if(($song["flags"]&0x2000)!=0)	// do we have a APIC frame?
    {
      $file=rawurlencode($MP3ROOT . $song["file"]);

      $table2->push_row(create_TD(array("class"=>"Image", "ROWSPAN"=>(pg_numfields($result)+1), 
					"WIDTH"=>"0%", "VALIGN"=>"TOP"),
		 		  new IMGtag(array("SRC"=>"$GETAPIC$file", "BORDER"=>"1", "ALT"=>"[cover]"))));
    }

    for($i=0; $i<pg_numfields($result); $i++)
    {
      $name=pg_fieldname($result, $i);
      $uname=ucfirst($name);

      $val=$song[$i];

      if($name=="flags")
        $val=decodeFlags($val)." [".sprintf("0x%08X", $val)."]";
      else if($name=="genre")
        $val=getGenre($val);
      else if($name=="filesize")
        $val=formatSize($val);
      else if($name=="length")
        $val=formatSeconds($val);
      else if($name=="bitrate")
        $val="$val kbps";

      $val=htmlspecialchars($val);
      
      $style="Entry";
      if(strlen($val)==0)
        $style="NoEntry";

      $table2->push_row(create_TD(array("class"=>"Column", "ALIGN"=>"LEFT"), create_B("$uname:")),
			create_TD(array("class"=>"$style", "WIDTH"=>"100%", "ALIGN"=>"LEFT"), $val));
    }

    $table1->push_row(create_TD(array("class"=>"Content", "VALIGN"=>"TOP", "HEIGHT"=>"100%"), $table2));
  }

  if($HAS_JS)
  {
    $table2=new TABLEtag(array("WIDTH"=>"100%"));

    $table2->push_row(create_TD(array("class"=>"Name", "ALIGN"=>"CENTER", "COLSPAN"=>"4"), 
				array("[", html_a("javascript:window.close()", "close"), "]")));

    $table1->push_row(create_TD(array("class"=>"Title", "VALIGN"=>"TOP"), $table2));
  }
}

$HTMLPage->push($table1);
print $HTMLPage->render();

?>
